/*! HTML5 Boilerplate v9.0.1 | MIT License | https://html5boilerplate.com/ */

/* main.css 3.0.0 | MIT License | https://github.com/h5bp/main.css#readme */
/*
 * What follows is the result of much research on cross-browser styling.
 * Credit left inline and big thanks to Nicolas Gallagher, Jonathan Neal,
 * Kroc Camen, and the H5BP dev community and team.
 */

/* ==========================================================================
   Base styles: opinionated defaults
   ========================================================================== */

html {
    color: #222;
    font-size: 1em;
    line-height: 1.4;
}

/*
 * Remove text-shadow in selection highlight:
 * https://twitter.com/miketaylr/status/12228805301
 *
 * Customize the background color to match your design.
 */

::-moz-selection {
    background: #b3d4fc;
    text-shadow: none;
}

::selection {
    background: #b3d4fc;
    text-shadow: none;
}

/*
 * A better looking default horizontal rule
 */

hr {
    display: block;
    height: 1px;
    border: 0;
    border-top: 1px solid #ccc;
    margin: 1em 0;
    padding: 0;
}

/*
 * Remove the gap between audio, canvas, iframes,
 * images, videos and the bottom of their containers:
 * https://github.com/h5bp/html5-boilerplate/issues/440
 */

audio,
canvas,
iframe,
img,
svg,
video {
    vertical-align: middle;
}

/*
 * Remove default fieldset styles.
 */

fieldset {
    border: 0;
    margin: 0;
    padding: 0;
}

/*
 * Allow only vertical resizing of textareas.
 */

textarea {
    resize: vertical;
}

/* ==========================================================================
   Author's custom styles
   ========================================================================== */

/* ==========================================================================
   Helper classes
   ========================================================================== */

/*
 * Hide visually and from screen readers
 */

.hidden,
[hidden] {
    display: none !important;
}

/*
 * Hide only visually, but have it available for screen readers:
 * https://snook.ca/archives/html_and_css/hiding-content-for-accessibility
 *
 * 1. For long content, line feeds are not interpreted as spaces and small width
 *    causes content to wrap 1 word per line:
 *    https://medium.com/@jessebeach/beware-smushed-off-screen-accessible-text-5952a4c2cbfe
 */

.visually-hidden {
    border: 0;
    clip: rect(0, 0, 0, 0);
    height: 1px;
    margin: -1px;
    overflow: hidden;
    padding: 0;
    position: absolute;
    white-space: nowrap;
    width: 1px;
    /* 1 */
}

/*
 * Extends the .visually-hidden class to allow the element
 * to be focusable when navigated to via the keyboard:
 * https://www.drupal.org/node/897638
 */

.visually-hidden.focusable:active,
.visually-hidden.focusable:focus {
    clip: auto;
    height: auto;
    margin: 0;
    overflow: visible;
    position: static;
    white-space: inherit;
    width: auto;
}

/*
 * Hide visually and from screen readers, but maintain layout
 */

.invisible {
    visibility: hidden;
}

/*
 * Clearfix: contain floats
 *
 * The use of `table` rather than `block` is only necessary if using
 * `::before` to contain the top-margins of child elements.
 */

.clearfix::before,
.clearfix::after {
    content: "";
    display: table;
}

.clearfix::after {
    clear: both;
}

/* ==========================================================================
   EXAMPLE Media Queries for Responsive Design.
   These examples override the primary ('mobile first') styles.
   Modify as content requires.
   ========================================================================== */

@media only screen and (min-width: 35em) {
    /* Style adjustments for viewports that meet the condition */
}

@media print,
(-webkit-min-device-pixel-ratio: 1.25),
(min-resolution: 1.25dppx),
(min-resolution: 120dpi) {
    /* Style adjustments for high resolution devices */
}

/* ==========================================================================
   Print styles.
   Inlined to avoid the additional HTTP request:
   https://www.phpied.com/delay-loading-your-print-css/
   ========================================================================== */

@media print {
    *,
    *::before,
    *::after {
        background: #fff !important;
        color: #000 !important;
        /* Black prints faster */
        box-shadow: none !important;
        text-shadow: none !important;
    }

    a,
    a:visited {
        text-decoration: underline;
    }

    a[href]::after {
        content: " (" attr(href) ")";
    }

    abbr[title]::after {
        content: " (" attr(title) ")";
    }

    /*
     * Don't show links that are fragment identifiers,
     * or use the `javascript:` pseudo protocol
     */
    a[href^="#"]::after,
    a[href^="javascript:"]::after {
        content: "";
    }

    pre {
        white-space: pre-wrap !important;
    }

    pre,
    blockquote {
        border: 1px solid #999;
        page-break-inside: avoid;
    }

    tr,
    img {
        page-break-inside: avoid;
    }

    p,
    h2,
    h3 {
        orphans: 3;
        widows: 3;
    }

    h2,
    h3 {
        page-break-after: avoid;
    }
}

* {
    outline: 1px solid red; /* Временная рамка для диагностики */
  }

html, body {
    height: 100dvh; /* Устанавливаем высоту для html и body на 100% */
    max-width: 100vw;
    margin: 0; /* Убираем отступы */
    padding: 0; /* Убираем поля */
    box-sizing: border-box; /* Обеспечиваем учет padding и border в размерах элемента */
}

/* Фон для всей страницы */
body {
    font-family: Arial, sans-serif;
    /* min-height: 100dvh; /* Используем dynamic viewport height вместо vh */
    display: flex; /* Flexbox для центрирования */
    justify-content: center; /* Центрируем по горизонтали */
    align-items: center; /* Центрируем по вертикали */
}

.page-container {
    width: 100%;
    height: 100%;
    margin: 0;
    padding: 0;

    display: flex; /* Flexbox для центрирования */
    justify-content: center; /* Центрируем по горизонтали */
}

.paper-1 {
    background-image: url('../img/pattern3.png'); /* URL изображения для узора */
    background-repeat: repeat; /* Повторение узора */
    background-size: 150px 150px; /* Размер узора, можно настроить */
    background-color: rgba(255, 255, 255, 0.9); /* Полупрозрачный белый фон для контейнера */
}

.paper-2 {
    /*background-image: url('../img/pattern3.png'); !* URL изображения для узора *!*/
    /*background-repeat: repeat; !* Повторение узора *!*/
    /*background-size: 150px 150px; !* Размер узора, можно настроить *!*/
    background-color: #FFFFFFFF; /* Полупрозрачный белый фон для контейнера */
}


.container-a1a {
    max-width: 400px;
    width: 100%;
    height: 100%;

    display: grid;
    grid-template-rows: auto 1fr auto auto auto;

    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
}

.container-1a {
    max-width: 400px;
    width: 100%;
    height: 100%;

    display: grid;
    grid-template-rows: 1fr auto auto auto;

    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
}

.container-a {
    width: 400px;
    height: 100%;
    overflow-y: auto;

    display: flex;
    flex-direction: column; /* Располагаем элементы вертикально */

    padding: 10px;
    /*box-sizing: content-box; !* Считаем padding в размер элемента *!*/
    box-sizing: border-box; /* Обеспечиваем учет padding и border в размерах элемента */
    border-radius: 10px; /* Закругленные углы */
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1); /* Легкая тень для контейнера */
}

/* Контейнер с сообщениями */
.container-yflex {
    width: 100%;
    min-height: 0; /* Минимальная высота 0, чтобы работать с flex-grow */
    overflow-y: auto;

    padding: 10px;
    /*box-sizing: content-box; /* Считаем padding в размер элемента */
    /*если сделать его сеткой, то компоненты растянутся на весь размер*/
    /*display: grid; !* Объявляем Grid-контейнер *!*/
    /*align-items: start; !* Элементы занимают только необходимую высоту *!*/

    /*ПРИЖАТЬ ВПРАВО в-т - флекс для чайлдов, чтобы прижать к правому краю */
    /*Д б флекс, тк грид ведёт себя совсем не так как надо*/
    display: flex; /* Flexbox для управления выравниванием */
    flex-direction: column; /* Располагаем элементы вертикально */
    /*align-items: flex-end; !* Прижимаем элементы (сообщения) (ЧАЙЛДЫ!) к правому краю *!*/
    box-sizing: border-box; /* Обеспечиваем учет padding и border в размерах элемента */
    gap: 2px; /* Добавляем свойство gap для управления расстоянием между элементами */

    /*пропадает скрол*/
    /*justify-content: flex-end; !* Прижимаем элементы к низу контейнера *!*/

}

.message {
    padding: 5px; /* Внутренний отступ */
    margin: 0 0; /* Отступ между сообщениями */
    border: 1px solid #ddd; /* Легкая рамка */
    max-width: 70%; /* Максимальная ширина сообщения */
    word-wrap: break-word; /* Перенос слов */

    border-radius: 10px; /* Один угол оставляем без закругления */
    border-bottom-left-radius: 0; /* Один угол оставляем без закругления */
    background-color: #cce5ffaa; /* Цвет фона по умолчанию */

    align-self: flex-start; /* Прижимаем (ЭТОТ) элемент (только когда внутри флекса)*/
    justify-self: start; /* Прижимаем элемент (если это чайлд грида!) */
    text-align: left; /* Выравниваем текст внутри сообщений по левому краю */
}

.i-am-author {
    /*.message:nth-child(odd) {*/
    align-self: flex-end; /* Прижимаем (ЭТОТ) элемент к левому краю (только когда внутри флекса)*/
    justify-self: end; /* Прижимаем элемент к правому краю ячейки (если это чайлд грида!) */
    text-align: right; /* Выравниваем текст внутри сообщений по левому краю */

    background-color: #aadde5aa; /* Цвет фона по умолчанию */
    border-radius: 10px; /* Закругленные углы */
    border-bottom-right-radius: 0; /* Один угол оставляем без закругления */

}

.system-author {
    /*.message:nth-child(odd) {*/
    align-self: center;
    text-align: center;

    background-color: #aaaaaa33; /* Цвет фона по умолчанию */
    border-radius: 10px; /* Закругленные углы */
    border-bottom-right-radius: 0; /* Один угол оставляем без закругления */

}


.blog-as-messages {
    padding: 5px; /* Внутренний отступ */
    margin: 5px 0; /* Отступ между сообщениями */
    border: 1px solid #ddd; /* Легкая рамка */
    min-width: 90%; /* Максимальная ширина сообщения */


    border-radius: 10px; /* Закругленные углы */
    border-bottom-right-radius: 0; /* Один угол оставляем без закругления */
    background-color: #cce5ffaa; /* Цвет фона по умолчанию */


    align-self: flex-start; /* Прижимаем (ЭТОТ) элемент (только когда внутри флекса?)*/
    justify-self: start; /* Прижимаем элемент (если это чайлд грида!) */
    text-align: justify; /* Выравниваем текст внутри сообщений по левому краю */
    word-wrap: break-word; /* Перенос слов */

    hyphens: auto; /* Добавляет автоматические переносы */
    line-height: 1.5; /* Увеличивает межстрочный интервал */
}

.blog-as-messages-right {
    align-self: flex-end; /* Прижимаем (ЭТОТ) элемент к левому краю (только когда внутри флекса?)*/
    border-bottom-right-radius: 10px; /* Один угол оставляем без закругления */
    border-bottom-left-radius: 0; /* Один угол оставляем без закругления */
}

.info {
    padding: 5px; /* Внутренний отступ */
    margin: 5px 0; /* Отступ между сообщениями */
    background-color: #cce5ffaa; /* Цвет фона по умолчанию */
    text-align: center; /* Выравниваем текст внутри сообщений по левому краю */
}

.button {
    padding: 5px; /* Внутренний отступ */
    margin: 5px 0; /* Отступ между сообщениями */
    align-self: center;
    border-radius: 10px; /* Закругленные углы */
    background-color: #cce5ffaa; /* Цвет фона по умолчанию */
    border: 1px solid #ddd; /* Легкая рамка */
    width: 50%; /* Максимальная ширина сообщения */
    word-wrap: break-word; /* Перенос слов */
    text-align: center; /* Выравниваем текст внутри сообщений по левому краю */

}


/* Контейнер для панели ввода */
.input-panel {
    width: 100%; /* Ширина панели ввода */
    grid-row: 3; /* Размещаем в строке 3 сетки */
}

.inputField {
    /*width: 80%; !* Заполняем всю ширину контейнера *!*/
    /*height: 100px; !* Фиксированная высота *!*/
    /*resize: none; !* Отключаем возможность изменения размера *!*/
    padding: 10px; /* Внутренний отступ */
    margin: 10px 10px; /* Отступ сверху и снизу */
    border: 1px solid #ddd; /* Легкая рамка */
    border-radius: 10px; /* Закругленные углы */
    font-family: Arial, sans-serif; /* Шрифт */
    /* should be 16px+, because else mobile browsers can zoom in */
    font-size: 16px; /* Размер шрифта */
    background-color: #f9f9f9; /* Фоновый цвет */
    box-shadow: inset 0 1px 3px rgba(0, 0, 0, 0.1); /* Тень внутри поля */
}

#custom-context-menu div {
    padding: 8px 12px;
    cursor: pointer;
}

#custom-context-menu div:hover {
    background-color: #f0f0f0;
}

#custom-context-menu {
    transition: opacity 0.2s ease;
    opacity: 0;
}

#custom-context-menu.show {
    opacity: 1;
}